'*******************************************************************************
' Module      : Mod 10v1 and Mod 97 Check Digit Calculation
' Author      : tlim
' Published   : 14/08/2008 4:12:02 PM
' Update      : 14/08/2008 4:12:06 PM
' Purpose     :
' Test Results: Value in [XX] is the Check Digit 
' 								Log Results
' 								------ Mod Calc 10 Start ------
' 								Date and Time: 8/14/2008 4:09:16 PM
' 								Line Count: 14
' 								Value: 8499  [6]
' 								Value: 8551  [4]
' 								Value: 8952  [4]
' 								Value: 8953  [2]
' 								Value: 42645  [2]
' 								Value: 121540  [9]
' 								Value: 121542  [5]
' 								Value: 146830  [5]
' 								Value: 152823  [1]
' 								Value: 152863  [7]
' 								Value: 182697  [3]
' 								Value: 200249  [1]
' 								Value: 200401  [8]
' 								Value: 676639  [8]
' 								------ Mod Calc 10 Complete ------
' 								
' 								Log Results
' 								------ Mod Calc 97 Start ------
' 								Date and Time: 8/14/2008 4:10:48 PM
' 								Line Count: 14
' 								Value: 8499  [79]
' 								Value: 8551  [55]
' 								Value: 8952  [50]
' 								Value: 8953  [70]
' 								Value: 42645  [96]
' 								Value: 121540  [41]
' 								Value: 121542  [81]
' 								Value: 146830  [96]
' 								Value: 152823  [85]
' 								Value: 152863  [64]
' 								Value: 182697  [19]
' 								Value: 200249  [36]
' 								Value: 200401  [30]
' 								Value: 676639  [72]
' 								------ Mod Calc 97 Complete ------

'*******************************************************************************

Const module_name  = "Mod 10 - Mod 97 Check Digit"
Const module_ver   = "1.00"   

Sub GetMod97
Dim sArrRow, i
Dim sOriginalVal, sModVal
Dim strHold
Const iVendorNo = 5000	' Vendor Assigned Number
Const iModPad = 6				' Pad Length for Original Value

    '// Clear Log
		logClear()
    
    '// Get working text
    text = handleSelText("")

		sArrRow = split(text, vbCRLF)
  	logAddLine("------ Mod Calc 97 Start ------")
  	logAddLine("Date and Time: " & Now())
    logAddLine("Line Count: " & ubound(sArrRow)+1)
				
    For i = lbound(sArrRow) to ubound(sArrRow)
			sOriginalVal = sArrRow(i)	 
			sModVal = Calc_Mod97(sOriginalVal, iVendorNo)		 
			
			IF i = ubound(sArrRow) Then
				  strHold = strHold & PadString(sOriginalVal, iModPad, "") & " - " & sModVal
				else
				  strHold = strHold & PadString(sOriginalVal, iModPad, "") & " - " & sModVal & vbCRLF
			End If
							 														
			logAddLine("Value: " & sOriginalVal & "  [" & sModVal & "]")							
    Next    				 

		logAddLine("------ Mod Calc 97 Complete ------")

		handleSelText strHold
		
End Sub

Sub GetMod10
Dim sArrRow, i
Dim sOriginalVal, sModVal
Dim strHold
Const iModPad = 6				' Pad Length for Original Value

    '// Clear Log
		logClear()
    
    '// Get working text
    text = handleSelText("")

		sArrRow = split(text, vbCRLF)
  	logAddLine("------ Mod Calc 10 Start ------")
  	logAddLine("Date and Time: " & Now())
    logAddLine("Line Count: " & ubound(sArrRow)+1)
				
    For i = lbound(sArrRow) to ubound(sArrRow)			
			sOriginalVal = sArrRow(i)	 
			sModVal = Calc_Mod10(sOriginalVal)		 
			
			IF i = ubound(sArrRow) Then
				  strHold = strHold & PadString(sOriginalVal, iModPad, "") & " - " & sModVal
				else
				  strHold = strHold & PadString(sOriginalVal, iModPad, "") & " - " & sModVal & vbCRLF
			End If
							 														
			logAddLine("Value: " & sOriginalVal & "  [" & sModVal & "]")								
    Next    				 

		logAddLine("------ Mod Calc 10 Complete ------")

		handleSelText strHold
		
End Sub

'///////////////////////////////////////////////////////////////////////////////
'//                      Global Procedures and Functions                      //
'///////////////////////////////////////////////////////////////////////////////

' Function to Calculate Mod10 Check Digits'
Private Function Calc_Mod10(idWithoutCheckDigit)
  ucIdWithoutCheckdigit = UCase(idWithoutCheckDigit)
  Total = 0
  For i = Len(ucIdWithoutCheckdigit) To 1 Step -2
      Digit = Asc(Mid(ucIdWithoutCheckdigit, i, 1)) - 48
      Total = Total + (2 * Digit) - Int(Digit / 5) * 9
      If i > 1 Then
          Digit = Asc(Mid(ucIdWithoutCheckdigit, i - 1, 1)) - 48
          Total = Total + Digit
      End If
  Next
  Total = Abs(Total) + 10
  Calc_Mod10 = (10 - (Total Mod 10)) Mod 10
 
End Function

'*******************************************************************************
' Function to Calculate Mod97 Check Digits'
Private Function Calc_Mod97(ReferenceID, VendorNo)
Dim i, j
'Dim VendorNo 'Used for Testing
Dim Mod_Val

'VendorNo = "5000"  ' Set in GetMod97
Mod_Val = "97"

Dim arrWeights
Dim arrReFID

Dim sumW

Dim Keying_Line
Dim MOD_Remainder
Dim Check_Digit
Dim CheckSum_Weights

CheckSum_Weights = "1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20"

' Variable to build Complete 19 digit keying string
Keying_Line = VendorNo & PadString(ReferenceID,"","")

' Re-Dimension Reference ID array
ReDim arrReFID(Len(Keying_Line) - 1)

' Split Reference ID String into Individual elements
For j = 0 To Len(Keying_Line) - 1
    arrReFID(j) = Mid(Keying_Line, j + 1, 1)
Next

arrWeights = Split(CheckSum_Weights, ",", -1)
sumW = 0

For i = LBound(arrWeights) To UBound(arrWeights)
    sumW = sumW + (arrWeights(i) * arrReFID(i))
Next

MOD_Remainder = sumW Mod Mod_Val
Check_Digit = Mod_Val - MOD_Remainder

Calc_Mod97 = MOD_Remainder

End Function

' Padding Function
Private Function PadString(strPad, padLen, boolLeft)
Dim tmpStr

tmpStr = strPad

If padLen = "" Then
	 padLen = 16
End If	 

If boolLeft = "" Then
	 boolLeft = True
End If

Select Case boolLeft
  Case True ' Pad Left
		Do While Len(tmpStr) < padLen
		    tmpStr = String(1, "0") & tmpStr
		Loop
	Case False ' Pad Right
		Do While Len(tmpStr) < padLen
		    tmpStr = tmpStr & String(1, "0")
		Loop
End Select
		
PadString = tmpStr

End Function

'// @param string Text to replace selected text
Private Function handleSelText(text)
dim BBX, BBY, BEX, BEY
    On Error Resume Next
    Set editor = newEditor()
    editor.assignActiveEditor
    
    If text = "" Then
        '// Get selected text                
        handleSelText = editor.selText
        If handleSelText = "" Then
            '// No text was select. Get all text and select it.
            handleSelText  = editor.Text
            editor.command "ecSelectAll"
        End If
    Else
        '// Set selected text
        editor.selText text
    End If
End Function

Sub Init
		menuName = "&" & module_name
		addMenuItem "Mod 10 Check Digit", menuName, "GetMod10"
    addMenuItem "Mod 97 Check Digit", menuName, "GetMod97"
End Sub
